#!/usr/bin/perl
#
# ====================================================================
# ■■　ひみこーど for Force 264　V3.1以降用　■■
# arranged by あじ Friday, November 22, 2002
# 
# これはフェイザー攻撃防御のための画像式ランダムチェックコードを生成する
# ための補助スクリプトです。（※ V3.1以降用）
# ひみこさん作の「ひみこ版 bitmap 数字コード生成 CGI」を利用
# 
# ■ このスクリプト（ひみこーど）について
# 
# これはひみこさんの許可を得て-Force 264-で改造配布しているものです。
# ですので、配布する場合は掲示板本体とセットで配布して下さい。
# 改造の有無を問わず、このスクリプト（ひみこーど）自体を単体で配布することは
# 出来ません。
# 
# ■ 追記（あじ）
# 
# このスクリプトは従来 XBM を出力していた「ひみこーど」をベースに
# 改造を施し、GIFアニメではない1枚のGIFとしてコードを表示するものです。
# 
# 主な改造点
# 　無圧縮GIF出力に変更。(special thanks pikoさん)
# 　文字の回転と拡大を廃止。
# 　フォントのデータをライブラリ化して追加を容易にした。
# 　透過GIF対応
# 　4色GIFに変更
# 
# 
#---------------- 初期設定  --------------#

# 発行済みチェックコードを保存するファイル
#	【注意】必ず掲示板本体スクリプトの初期設定と合わせること

$himicode_log = "himiko.cgi";


# 保存件数（設定数以上は古いものから順に削除）
#	アクセス数が多い場合は増やす。

$maxline = '200';


# 表示する数字の桁数
#	むやみに桁数を増やすと負荷や転送量も増える

# 最小桁数
$MIN_DIGIT = 3;

# 最大桁数
$MAX_DIGIT = 3;


# 文字デザイン定義ライブラリ
#	下記の様に並べればいくつでもおけ。
#	ライブラリは実際見れば分かる通り簡単なので、自作するとさらに強度アップ。
#	自作時は、幅・高さはばらばらも可。同一字体でも大きさを変えるだけでも効果あり。

@TEMPLATE = ("normal.pl");


# 各桁の文字フォント
#	ランダムの場合でも、同一のライブラリ内のみ(１回のアクセスで複数ライブラリは使用しない)

$FONT = 0;# 0:全桁同一 1:各桁ランダム 2: 0と1をランダム


# 解析予防
#	文字位置、文字に影を付加、ノイズの付加、文字サイズの変更により解析しにくくする。
#	文字サイズ変更を使うと、当然、画像サイズが大きくなり転送量等も増える。

# 文字位置(使用時は余白($H_MARGIN や $V_MARGIN)を 4 以上に)
$POSITION_ADJ = 2;	# 0:固定 1:数字全体を移動 2:各桁ごとに移動

# 影付き
$SILHOUETTE = 2;	# 0:OFF 1:ON 2:ランダム($H_MARGIN が小さい場合影が付かないこともあります)

# ノイズ量(10以上に設定すると心眼が必要)
$NOISE_DENSITY = 0;	# 0:ノイズ無し　1〜数値の大きさに応じてノイズ増

# 文字サイズ変更
$R_SIZE = 0;		# 0:OFF 1:ON


# 余白
#	文字位置を可変する時は、縦横共に 4 以上にする。
#	１文字分の横幅は、フォント幅＋$H_MARGIN * 2
#	画像高さは、文字高さ＋$V_MARGIN * 2

# 横方向余白
$H_MARGIN = 6;		# 1 以上

# 縦方向余白
$V_MARGIN = 6;		# 1 以上


# 表示色設定
# 【注意】" " で囲み忘れると変な色になる(笑
#	前景色は３色以下でもデータ上は４色(４個のカラーテーブルを持った) GIF として出力する。
#	前景色は使用する色を配列からランダムに選択。透過GIFとして使用するとき、透過色が露骨に
#	他の色と指定が違うと分りやすいので、前景色から１色をこれまたランダムに選択(笑
#	つまり前景色部分全部にノイズを掛けたのと同じような感じなので少し解析が面倒になる…と思う、多分…
#	…まぁ…色々弄って遊んでみて…

# 背景色( "" にすると透過GIFになる )
$Back_Color = "";

# 前景色セット(あらかじめ用意してあるFont_Color)の利用
$Use_Color_Set = 1;	# 0:使わない　1:背景が白系　2:背景が黒系　3:背景が赤明色　4:背景が赤暗色　5:背景が緑明色　6:背景が緑暗色　7:背景が青明色　8:背景が青暗色

# 前景色(1色でも問題なし。最大100色まで。$Use_Color_Set を使用すれば定義しなくても可)
@Font_Color = (	"FF0000","FF0033","FF0066","FF0099","FF00CC","FF00FF","FF3300","FF3333","FF3366","FF3399","FF33CC","FF33FF",
		"FF6600","FF6633","FF6666","FF6699","FF66CC","FF66FF","FF9900","FF9933","FF9966","FF9999","FF99CC","FF99FF",
		"FFCC00","FFCC33","FFCC66","FFCC99","FFCCCC","FFCCFF","FFFF00","FFFF33","FFFF66","FFFF99","FFFFCC","FFFFFF");


#-----------------設定ここまで----------------#
 
# 前景色セット(お徳用)

if($Use_Color_Set == 1){
	@Font_Color = (	"006600","006633","006666","006699","0066CC","0066FF","336600","336633","336666","336699","3366CC","3366FF",
			"666600","666633","666666","666699","6666CC","6666FF","996600","996633","996666","996699","9966CC","9966FF",
			"CC6600","CC6633","CC6666","CC6699","CC66CC","CC66FF","FF6600","FF6633","FF6666","FF6699","FF66CC","FF66FF");
}elsif($Use_Color_Set == 2){
	@Font_Color = (	"CC9900","CC9933","CC9966","CC9999","CC99CC","CC99FF","FF9900","FF9933","FF9966","FF9999","9999CC","9999FF",
			"CCCC00","CCCC33","CCCC66","CCCC99","CCCCCC","CCCCFF","FFCC00","FFCC33","FFCC66","FFCC99","99CCCC","99CCFF",
			"CCFF00","CCFF33","CCFF66","CCFF99","CCFFCC","CCFFFF","FFFF00","FFFF33","FFFF66","FFFF99","99FFCC","99FFFF");
}elsif($Use_Color_Set == 3){
	@Font_Color = (	"006600","006633","006666","006699","0066CC","0066FF","336600","336633","336666","336699","3366CC","3366FF",
			"666600","666633","666666","666699","6666CC","6666FF","009900","009933","009966","009999","0099CC","0099FF",
			"339900","339933","339966","339999","3399CC","3399FF","669900","669933","669966","669999","6699CC","6699FF");
}elsif($Use_Color_Set == 4){
	@Font_Color = (	"00CC00","00CC33","00CC66","00CC99","00CCCC","00CCFF","33CC00","33CC33","33CC66","33CC99","33CCCC","33CCFF",
			"66CC00","66CC33","66CC66","66CC99","66CCCC","66CCFF","99FF00","99FF33","99FF66","99FF99","99FFCC","99FFFF",
			"CCFF00","CCFF33","CCFF66","CCFF99","CCFFCC","CCFFFF","FFFF00","FFFF33","FFFF66","FFFF99","FFFFCC","FFFFFF");
}elsif($Use_Color_Set == 5){
	@Font_Color = (	"990000","990033","990066","990099","9900CC","9900FF","CC0000","CC0033","CC0066","CC0099","CC00CC","CC00FF",
			"FF0000","FF0033","FF0066","FF0099","FF00CC","FF00FF","993300","993333","993366","993399","9933CC","9933FF",
			"CC3300","CC3333","CC3366","CC3399","CC33CC","CC33FF","FF3300","FF3333","FF3366","FF3399","FF33CC","FF33FF");
}elsif($Use_Color_Set == 6){
	@Font_Color = (	"CC9900","CC9933","CC9966","CC9999","CC99CC","CC99FF","FF9900","FF9933","FF9966","FF9999","FF99CC","FF99FF",
			"CCCC00","CCCC33","CCCC66","CCCC99","CCCCCC","CCCCFF","FFCC00","FFCC33","FFCC66","FFCC99","FFCCCC","FFCCFF",
			"CCFF00","CCFF33","CCFF66","CCFF99","CCFFCC","CCFFFF","FFFF00","FFFF33","FFFF66","FFFF99","FFFFCC","FFFFFF");
}elsif($Use_Color_Set == 7){
	@Font_Color = (	"006600","006633","006666","336600","336633","336666","666600","666633","666666","996600","996633","996666",
			"CC6600","CC6633","CC6666","FF6600","FF6633","FF6666","009900","009933","009966","339900","339933","339966",
			"669900","669933","669966","999900","999933","999966","CC9900","CC9933","CC9966","FF9900","FF9933","FF9966");
}elsif($Use_Color_Set == 8){
	@Font_Color = (	"99CC00","99CC33","99CC66","99CC99","99CCCC","99CCFF","99FF00","99FF33","99FF66","99FF99","99FFCC","99FFFF",
			"CCCC00","CCCC33","CCCC66","CCCC99","CCCCCC","CCCCFF","FFCC00","FFCC33","FFCC66","FFCC99","FFCCCC","FFCCFF",
			"CCFF00","CCFF33","CCFF66","CCFF99","CCFFCC","CCFFFF","FFFF00","FFFF33","FFFF66","FFFF99","FFFFCC","FFFFFF");
}

#-----------------メインルーチン----------------#

srand (time|$$);

# ランダム桁のランダム数字の生成
$max_num =1;
$min_num =1;
for( ; ; ){
	$num_digit = rand($MAX_DIGIT)%$MAX_DIGIT+1;
	last if($num_digit >= $MIN_DIGIT);
}
for($i=0; $i<$num_digit; $i++){ $max_num *= 10; }
$min_num = $max_num/10;
for( ; ; ){
	$num = rand($max_num)%$max_num;
	last if($num >= $min_num);
}

# 引数（りもーとぽーと）とともにファイルへ記録
$ARGV[0] = $ENV{QUERY_STRING};#ハイパー対策
$himiko = $num . $ARGV[0];
open(LOG,"+< $himicode_log") || die "Can't Open himicode Log: $!\n";
eval { flock(LOG, 2); }; 
@lines = <LOG>;
eval { seek(LOG, 0, 0); };
# 新しいデータを配列の先頭に追加
unshift(@lines, "$himiko\n");
# 要素数が$maxlineより多いデータを削除
@lines = @lines[0..$maxline - 1];
print LOG @lines;
eval { truncate(LOG, tell(LOG)); };
close(LOG);

# ライブラリの呼び出し
$i = @TEMPLATE;
$j = rand(100) % $i;
$library = $TEMPLATE[$j];
require $library;
&make_template;
$i = 0;
while ($base[$i][0][0] =~ /[0-1]+/ ) { $i++; $kind = $i; } # ライブラリ内のフォントの数

# 配色
@color = ("0","0","0","0");
$tci = int(rand(39)) %4;	# 背景色をカラーテーブルの何番に定義するか
if($Back_Color){ $color[$tci] = $Back_Color; }else{ $color[$tci] = $Font_Color[int(rand(100)) % @Font_Color]; }
for(0..3){		# 残ったカラーテーブルにフォント色を入れる
	if($color[$_] eq "0"){ push(@fc,$_); $color[$_] = $Font_Color[int(rand(100)) % @Font_Color]; }
}
$rev = int(rand(10)) %2;

# 画像データ作成
$bmp = &make_bitmap;

# 出力用データのフォーマット
$buf = unpack("b3", chr(4));
($d,$e,$f,$g,$h,$i) = (2,8,15,4,3,6);
for(unpack('C*', $bmp)){
	$buf .= unpack("b$h", chr($_));
	if(++$i > $e){
		$e = 1 << (++$h);
	}elsif($i == $f){
		$buf .= unpack("b$h", chr($g));
		$e = 1 << ($h = $d + 1);
		$i = $g + 2;
	}
}
$buf .= unpack("b$h", chr($g + 1));
$buf = pack("b*", $buf);
$bmp = chr($d);
$j = 0;
do{
	$buffer = substr($buf, $j, 255);
	$j += 255;
	$bmp .= chr($g = length($buffer)) . $buffer;
}while($g == 255);

# GIF 画像出力
binmode STDOUT;
select(STDOUT);
$| = 1;
print "Content-type: image/gif\r\n\n";
print "GIF89a";
print pack('vv', $width, $height);
print pack('C3', 0x81, 0, 0);
print pack('a12', pack('H*', $color[0] . $color[1] . $color[2] . $color[3]));
if(!$Back_Color){ print pack('C*', 0x21, 0xf9, 0x04, 0x01, 0x00, 0x00, $tci, 0); }
print pack('CvvvvC', 0x2C, 0, 0, $width, $height, 0);
print $bmp;
print chr(0).";";
exit;

# ----- subroutine ----- 以下サブルーチン

sub make_bitmap {

if ($FONT > 1) { $FONT = int(rand(2)); }

# 個々のフォントデータ
@num = split(//,$num);
$i = 0;$j = 0;$m = 0;$x = 0;$y = 0;$z = 0;$k = int(rand($kind));$maxsize = 0;
@size = ();
@tmp = ();
foreach $n (@num) {
	if ($FONT) { $k = int(rand($kind)); }
	if ($R_SIZE) {
		$x = rand(30)%3;
		$y = rand(30)%3;
		$z = rand(30)%3;
	}
	while ($base[$k][$n][$j] =~ /[0-1]+/ ) {
		$bit = $base[$k][$n][$j];
		$bit =~ s/0/A/g;
		$bit =~ s/1/Z/g;
		if($y > 1) {
			$tmp[$i][$m] = $bit;
			if ($x > 1) { $tmp[$i][$m] =~ s/A/AA/ig; $tmp[$i][$m] =~ s/Z/ZZ/ig; }
			$m++;
		}
		$tmp[$i][$m] = $bit;
		if($x > 1) { $tmp[$i][$m] =~ s/A/AA/ig; $tmp[$i][$m] =~ s/Z/ZZ/ig; }
		$m++;
		$j++;
		if($y <= 1 && $z > 1 && $j%2 == 1){ $y = 1; }elsif($y > 1 && $z > 1 && $j%2 == 0){ $y = 0; } # 縦1.5倍
	}
	if ($maxsize < $m) { $maxsize = $m; }
	push(@size,$m);
	$j = 0;
	$m = 0;
	$i++;
}

# フォントデータの組立
if ($POSITION_ADJ == 0  || $H_MARGIN <= 2 || $V_MARGIN <= 2) {
	$POSITION_ADJ = 0;
	$left = $H_MARGIN;
	$down = $V_MARGIN;
} elsif ($POSITION_ADJ == 1) {
	$k = $H_MARGIN * 2 - 6;
	$left = int(rand($k)) + 3;
	$k = $V_MARGIN * 2 - 6;
	$down = int(rand($k)) + 3;
}
$height = $V_MARGIN * 2 + $maxsize;
$i = 0;$j = 0;
@str = ();
while ($tmp[$i][0] =~ /[AZ]+/ ) {
	if ($POSITION_ADJ == 2) {
		$k = $H_MARGIN * 2 - 6;
		$left = int(rand($k)) + 3;
		$k = $V_MARGIN * 2 - 6;
		$down = int(rand($k)) + 3;
	}
	$right = $H_MARGIN * 2 - $left;
	$up = $height - $down - $size[$i];
	$blank_w = "";
	for ($j=0; $j<$left; $j++) { $blank_w .= "A"; }		# 左の余白文字列
	for ($j=0; $j<=$height; $j++) { $str[$j] .= $blank_w; }	# 左余白を挿入
	$blank_h = $tmp[$i][0];					# フォントの一列を代入し
	$blank_h =~ s/Z/A/g;					# 0 に置換して余白文字列を作る
	for ($j=0; $j<=$up; $j++) { $str[$j] .= $blank_h; }	# 上余白を挿入
	for ($j=0; $j<$size[$i]; $j++) { $str[$j+$up+1] .= $tmp[$i][$j]; }		# フォントデータ挿入
	for ($j=0; $j<$down; $j++)   { $str[$j+$up+$size[$i]+1] .= $blank_h; }	# 下余白を挿入
	$blank_w = "";
	for ($j=0; $j<$right; $j++) { $blank_w .= "A"; }	# 右の余白文字列
	for ($j=0; $j<=$height; $j++) { $str[$j] .= $blank_w; }	# 右余白を挿入
	$i++;
}

# 影付き文字の処理
if ($SILHOUETTE == 1) { $SILHOUETTE = rand(70) + 30; }
elsif ($SILHOUETTE == 2) { $SILHOUETTE = rand(100); }
if ($SILHOUETTE > 60) {
	$j = 0;
	for (0..$#str) {
		$str[$j] =~ s/ZAAA/ZAZA/g;
		$j++;
	}
} elsif ($SILHOUETTE > 30) {
	$j = 0;
	for (0..$#str) {
		$str[$j] =~ s/AAAZ/AZAZ/g;
		$j++;
	}
}
$width = length($str[0]);

# ノイズ処理と色番号の割り当て
$bit = join("",@str);
@bits = split(//,$bit);
if(!$rev){ $a = "A"; $z = "Z"; }else{ $a = "Z"; $z = "A"; }
$bit = "";
foreach (@bits){
	$d = $_;
	$k = int(rand(100));
	if($NOISE_DENSITY > 0 && $k < $NOISE_DENSITY) {
		if($d eq $a){ $d = $z }else{ $d = $a }
	}
	if($d eq $a){
		$bit .= $tci
	}else{
		$k = $k % 3;
		$bit .= $fc[$k];
	}
}
return $bit;

}

# おしまい。
